package com.sun.org.apache.xml.internal.utils;

import org.w3c.dom.Attr;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.xml.sax.Attributes;

public class AttList implements Attributes
{
    NamedNodeMap m_attrs;
    int m_lastIndex;
    
    public AttList(NamedNodeMap attrs) {
        this.m_attrs = attrs;
        this.m_lastIndex = this.m_attrs.getLength() - 1;
    }
    
    @Override
    public int getLength() {
        return this.m_attrs.getLength();
    }
    
    @Override
    public String getURI(int index) {
        String ns = DOM2Helper.getNamespaceOfNode((Node)this.m_attrs.item(index));
        if (null == ns) {
            ns = "";
            return ns;
        }
        return ns;
    }
    
    @Override
    public String getLocalName(int index) {
        return DOM2Helper.getLocalNameOfNode((Node)this.m_attrs.item(index));
    }
    
    @Override
    public String getQName(int i) {
        return ((Attr)this.m_attrs.item(i)).getName();
    }
    
    @Override
    public String getType(int i) {
        return "CDATA";
    }
    
    @Override
    public String getValue(int i) {
        return ((Attr)this.m_attrs.item(i)).getValue();
    }
    
    @Override
    public String getType(String name) {
        return "CDATA";
    }
    
    @Override
    public String getType(String uri, String localName) {
        return "CDATA";
    }
    
    @Override
    public String getValue(String name) {
        Attr attr = (Attr)this.m_attrs.getNamedItem(name);
        return (null != attr) ? attr.getValue() : null;
    }
    
    @Override
    public String getValue(String uri, String localName) {
        Node a = this.m_attrs.getNamedItemNS(uri, localName);
        return (a == null) ? null : a.getNodeValue();
    }
    
    @Override
    public int getIndex(String uri, String localPart) {
        int i = this.m_attrs.getLength() - 1;
        while (i >= 0) {
            Node a = this.m_attrs.item(i);
            String u = a.getNamespaceURI();
            if (!((u != null) ? (!u.equals(uri)) : (uri != null)) && a.getLocalName().equals(localPart)) {
                return i;
            }
            --i;
        }
        return -1;
    }
    
    @Override
    public int getIndex(String qName) {
        int i = this.m_attrs.getLength() - 1;
        while (i >= 0) {
            Node a = this.m_attrs.item(i);
            if (a.getNodeName().equals(qName)) {
                return i;
            }
            --i;
        }
        return -1;
    }
}
